libosmovty 1.13.1.1-afb4 Osmocom VTY library

Files | Macros | Functions | Variables
Tnnn timer VTY configuration

VTY API for Tnnn timer configuration. More...

## Files
file | tdef_vty.h
| API to configure osmo_tdef Tnnn timers from VTY configuration.
file | tdef_vty.c
| Implementation to configure osmo_tdef Tnnn timers from VTY configuration.

## Macros
#define | OSMO_TDEF_VTY_ARG_T "TNNNN"
#define | OSMO_TDEF_VTY_DOC_T
#define | OSMO_TDEF_VTY_ARG_T_OPTIONAL "[" OSMO_TDEF_VTY_ARG_T "]"
#define | OSMO_TDEF_VTY_ARG_VAL "(<0-2147483647>|default)"
#define | OSMO_TDEF_VTY_DOC_VAL "New timer value\n" "Set to default timer value\n"
#define | OSMO_TDEF_VTY_ARG_VAL_OPTIONAL "[" OSMO_TDEF_VTY_ARG_VAL "]"
#define | OSMO_TDEF_VTY_ARG_SET OSMO_TDEF_VTY_ARG_T " " OSMO_TDEF_VTY_ARG_VAL
#define | OSMO_TDEF_VTY_DOC_SET OSMO_TDEF_VTY_DOC_T OSMO_TDEF_VTY_DOC_VAL
#define | OSMO_TDEF_VTY_ARG_SET_OPTIONAL OSMO_TDEF_VTY_ARG_T_OPTIONAL " " OSMO_TDEF_VTY_ARG_VAL_OPTIONAL

## Functions
int | osmo_tdef_vty_set_cmd (struct vty *vty, struct osmo_tdef *tdefs, const char **args)
| Apply a timer configuration from VTY argument strings. More...
int | osmo_tdef_vty_show_cmd (struct vty *vty, struct osmo_tdef *tdefs, const char *T_arg, const char *prefix_fmt,...)
| Output one or all timers to the VTY, as for a VTY command like 'show timer [TNNNN]'. More...
void | osmo_tdef_vty_write (struct vty *vty, struct osmo_tdef *tdefs, const char *prefix_fmt,...)
| Write current timer configuration arguments to the vty. More...
void | osmo_tdef_vty_out_one (struct vty *vty, struct osmo_tdef *t, const char *prefix_fmt,...)
| Write to VTY the current status of one timer. More...
void | osmo_tdef_vty_out_all (struct vty *vty, struct osmo_tdef *tdefs, const char *prefix_fmt,...)
| Write to VTY the current status of all given timers. More...
void | osmo_tdef_vty_out_one_va (struct vty *vty, struct osmo_tdef *t, const char *prefix_fmt, va_list va)
| Write to VTY the current status of one timer. More...
void | osmo_tdef_vty_out_all_va (struct vty *vty, struct osmo_tdef *tdefs, const char *prefix_fmt, va_list va)
| Write to VTY the current status of all given timers. More...
struct osmo_tdef * | osmo_tdef_vty_parse_T_arg (struct vty *vty, struct osmo_tdef *tdefs, const char *T_str)
| Parse an argument like "1234", "T1234", "t1234", or "X1234", "x1234", as from OSMO_TDEF_VTY_ARG_T. More...
unsigned long | osmo_tdef_vty_parse_val_arg (const char *val_arg, unsigned long default_val)
| Parse an argument of the form "(0-2147483647|default)", as from OSMO_TDEF_VTY_ARG_VAL. More...
void | osmo_tdef_vty_groups_init (unsigned int parent_cfg_node, struct osmo_tdef_group *groups)
| Convenience implementation for keeping a fixed set of timer groups in a program. More...
void | osmo_tdef_vty_groups_write (struct vty *vty, const char *indent)
| Write the global osmo_tdef_group configuration to VTY, as previously passed to osmo_tdef_vty_groups_init(). More...
| osmo_tdef_groups_for_each (g, global_tdef_groups)
| if (argc< 3) return show_timer(self
return | osmo_tdef_vty_set_cmd (vty, tdefs, timer_args)
static char * | add_group_args (void *talloc_ctx, char *dest)
static char * | add_group_docs (void *talloc_ctx, char *dest)
static char * | timer_command_string (const char *prefix, const char *suffix)
static char * | timer_doc_string (const char *prefix, const char *suffix)

## Variables
static struct osmo_tdef_group * | global_tdef_groups
| Singleton Tnnn groups definition as set by osmo_tdef_vty_groups_init(). More...
const char * | T_arg = argc > 1 ? argv[1] : NULL
struct osmo_tdef_group * | g = NULL
return | CMD_SUCCESS
const char ** | timer_args
struct osmo_tdef * | tdefs = NULL
| vty
| argc
| argv
| group_arg = argv[0]

## Detailed Description

VTY API for Tnnn timer configuration.

## Macro Definition Documentation

## ◆ OSMO_TDEF_VTY_ARG_SET

#define OSMO_TDEF_VTY_ARG_SET OSMO_TDEF_VTY_ARG_T " " OSMO_TDEF_VTY_ARG_VAL

## ◆ OSMO_TDEF_VTY_ARG_SET_OPTIONAL

#define OSMO_TDEF_VTY_ARG_SET_OPTIONAL OSMO_TDEF_VTY_ARG_T_OPTIONAL " " OSMO_TDEF_VTY_ARG_VAL_OPTIONAL

## ◆ OSMO_TDEF_VTY_ARG_T

#define OSMO_TDEF_VTY_ARG_T "TNNNN"

## ◆ OSMO_TDEF_VTY_ARG_T_OPTIONAL

#define OSMO_TDEF_VTY_ARG_T_OPTIONAL "[" OSMO_TDEF_VTY_ARG_T "]"

## ◆ OSMO_TDEF_VTY_ARG_VAL

#define OSMO_TDEF_VTY_ARG_VAL "(<0-2147483647>|default)"

## ◆ OSMO_TDEF_VTY_ARG_VAL_OPTIONAL

#define OSMO_TDEF_VTY_ARG_VAL_OPTIONAL "[" OSMO_TDEF_VTY_ARG_VAL "]"

## ◆ OSMO_TDEF_VTY_DOC_SET

#define OSMO_TDEF_VTY_DOC_SET OSMO_TDEF_VTY_DOC_T OSMO_TDEF_VTY_DOC_VAL

## ◆ OSMO_TDEF_VTY_DOC_T

#define OSMO_TDEF_VTY_DOC_T

Value:
"T- or X-timer-number -- 3GPP compliant timer number of the format '1234' or 'T1234' or 't1234';" \
" Osmocom-specific timer number of the format: 'X1234' or 'x1234'.\n"

## ◆ OSMO_TDEF_VTY_DOC_VAL

#define OSMO_TDEF_VTY_DOC_VAL "New timer value\n" "Set to default timer value\n"

## Function Documentation

## ◆ add_group_args()

static char * add_group_args | ( | void * | talloc_ctx,
|  | char * | dest
| ) |  |
| static

References g, global_tdef_groups, osmo_tdef_group::name, osmo_talloc_asprintf, and osmo_tdef_groups_for_each().

Referenced by timer_command_string().

## ◆ add_group_docs()

static char * add_group_docs | ( | void * | talloc_ctx,
|  | char * | dest
| ) |  |
| static

References osmo_tdef_group::desc, g, global_tdef_groups, osmo_talloc_asprintf, and osmo_tdef_groups_for_each().

Referenced by timer_doc_string().

## ◆ if()

if | ( |  | ) |

## ◆ osmo_tdef_groups_for_each()

osmo_tdef_groups_for_each | ( | g | ,
|  | global_tdef_groups |
| ) |  |

References g, group_arg, osmo_tdef_group::name, osmo_str_startswith(), osmo_tdef_vty_show_cmd(), T_arg, and osmo_tdef_group::tdefs.

Referenced by add_group_args(), add_group_docs(), osmo_tdef_vty_groups_init(), and osmo_tdef_vty_groups_write().

## ◆ osmo_tdef_vty_groups_init()

void osmo_tdef_vty_groups_init | ( | unsigned int | parent_cfg_node,
|  | struct osmo_tdef_group * | groups
| ) |  |

Convenience implementation for keeping a fixed set of timer groups in a program.

Install a 'timer [(group|names|...)] [TNNN] [(<val>|default)]' command under the given parent_node, and install a 'show timer...' command on VIEW_NODE and ENABLE_NODE. For a usage example, see tdef_test_config_root::c. The given timer definitions group is stored in a global pointer, so this can be done only once per main() scope. It would also be possible to have distinct timer groups on separate VTY subnodes, with a "manual" implementation, but not with this API.

Parameters

  [in] | parent_cfg_node | VTY node at which to add the timer configuration commands, e.g. CONFIG_NODE.
  [in] | groups | Global timer groups definition.

References g, global_tdef_groups, install_lib_element(), install_lib_element_ve(), OSMO_ASSERT, osmo_tdef_groups_for_each(), OSMO_TDEF_VTY_ARG_SET_OPTIONAL, OSMO_TDEF_VTY_ARG_T_OPTIONAL, OSMO_TDEF_VTY_DOC_SET, OSMO_TDEF_VTY_DOC_T, osmo_tdefs_reset(), SHOW_STR, osmo_tdef_group::tdefs, timer_command_string(), and timer_doc_string().

## ◆ osmo_tdef_vty_groups_write()

void osmo_tdef_vty_groups_write | ( | struct vty * | vty,
|  | const char * | indent
| ) |  |

Write the global osmo_tdef_group configuration to VTY, as previously passed to osmo_tdef_vty_groups_init().

Parameters

  [in] | vty | VTY context.
  [in] | indent | String to print before each line.

References g, global_tdef_groups, osmo_tdef_group::name, osmo_tdef_groups_for_each(), osmo_tdef_vty_write(), and osmo_tdef_group::tdefs.

## ◆ osmo_tdef_vty_out_all()

void osmo_tdef_vty_out_all | ( | struct vty * | vty,
|  | struct osmo_tdef * | tdefs,
|  | const char * | prefix_fmt,
|  |  | ...
| ) |  |

Write to VTY the current status of all given timers.

Parameters

  [in] | vty | VTY context for vty_out().
  [in] | tdefs | Array of timers to print, ended with a fully zero-initialized entry.
  [in] | prefix_fmt | Arbitrary string to start each line with, with variable printf like arguments.

References osmo_tdef_vty_out_all_va(), and tdefs.

## ◆ osmo_tdef_vty_out_all_va()

void osmo_tdef_vty_out_all_va | ( | struct vty * | vty,
|  | struct osmo_tdef * | tdefs,
|  | const char * | prefix_fmt,
|  | va_list | va
| ) |  |

Write to VTY the current status of all given timers.

Parameters

  [in] | vty | VTY context for vty_out().
  [in] | tdefs | Array of timers to print, ended with a fully zero-initialized entry.
  [in] | prefix_fmt | Arbitrary string to start each line with, with variable vprintf like arguments.
  [in] | va | va_list instance. As always, call va_start() before, and va_end() after this call.

References osmo_tdef_for_each, osmo_tdef_vty_out_one_va(), tdefs, VTY_NEWLINE, and vty_out().

Referenced by osmo_tdef_vty_out_all(), and osmo_tdef_vty_show_cmd().

## ◆ osmo_tdef_vty_out_one()

void osmo_tdef_vty_out_one | ( | struct vty * | vty,
|  | struct osmo_tdef * | t,
|  | const char * | prefix_fmt,
|  |  | ...
| ) |  |

Write to VTY the current status of one timer.

Parameters

  [in] | vty | VTY context for vty_out().
  [in] | t | The timer to print.
  [in] | prefix_fmt | Arbitrary string to start each line with, with variable printf like arguments.

References osmo_tdef_vty_out_one_va().

## ◆ osmo_tdef_vty_out_one_va()

void osmo_tdef_vty_out_one_va | ( | struct vty * | vty,
|  | struct osmo_tdef * | t,
|  | const char * | prefix_fmt,
|  | va_list | va
| ) |  |

Write to VTY the current status of one timer.

Parameters

  [in] | vty | VTY context for vty_out().
  [in] | t | The timer to print.
  [in] | prefix_fmt | Arbitrary string to start each line with, with variable vprintf like arguments.
  [in] | va | va_list instance. As always, call va_start() before, and va_end() after this call.

References osmo_tdef::default_val, osmo_tdef::desc, osmo_tdef::max_val, osmo_tdef::min_val, OSMO_T_FMT, OSMO_T_FMT_ARGS, OSMO_TDEF_CUSTOM, osmo_tdef_range_str_buf(), osmo_tdef_unit_name(), osmo_tdef::T, osmo_tdef::unit, osmo_tdef::val, VTY_NEWLINE, vty_out(), and vty_out_va().

Referenced by osmo_tdef_vty_out_all_va(), osmo_tdef_vty_out_one(), and osmo_tdef_vty_show_cmd().

## ◆ osmo_tdef_vty_parse_T_arg()

struct osmo_tdef * osmo_tdef_vty_parse_T_arg | ( | struct vty * | vty,
|  | struct osmo_tdef * | tdefs,
|  | const char * | T_str
| ) |  |

Parse an argument like "1234", "T1234", "t1234", or "X1234", "x1234", as from OSMO_TDEF_VTY_ARG_T.

Parameters

  [in] | vty | VTY context for vty_out() of error messages.
  [in] | tdefs | Array of timer definitions to look up T timer.
  [in] | T_str | Argument string. It is not validated, expected to be checked by VTY input.

Returns
  the corresponding osmo_tdef entry from the tdefs array, or NULL if no such entry exists.

References l, osmo_str_to_int(), OSMO_T_FMT, OSMO_T_FMT_ARGS, osmo_tdef_get_entry(), osmo_tdef::T, tdefs, VTY_NEWLINE, and vty_out().

Referenced by osmo_tdef_vty_set_cmd(), and osmo_tdef_vty_show_cmd().

## ◆ osmo_tdef_vty_parse_val_arg()

unsigned long osmo_tdef_vty_parse_val_arg | ( | const char * | val_arg,
|  | unsigned long | default_val
| ) |  |

Parse an argument of the form "(0-2147483647|default)", as from OSMO_TDEF_VTY_ARG_VAL.

Parameters

  [in] | val_arg | Argument string (not format checked).
  [in] | default_val | Value to return in case of val_arg being "default".

Returns
  Parsed value or default_val.

References osmo_tdef::default_val.

Referenced by osmo_tdef_vty_set_cmd().

## ◆ osmo_tdef_vty_set_cmd() [1/2]

int osmo_tdef_vty_set_cmd | ( | struct vty * | vty,
|  | struct osmo_tdef * | tdefs,
|  | const char ** | args
| ) |  |

Apply a timer configuration from VTY argument strings.

Employ both osmo_tdef_vty_parse_T_arg() and osmo_tdef_vty_parse_val_arg() to configure a T timer in an array of tdefs. Evaluate two arguments, a "T1234" argument and a "(0-2147483647|default)" argument, as from OSMO_TDEF_VTY_ARGS. If the T timer given in the first argument is found in tdefs, set it to the value given in the second argument.

Parameters

  [in] | vty | VTY context for vty_out() of error messages.
  [in] | tdefs | Array of timer definitions to look up T timer.
  [in] | args | Array of string arguments like { "T1234", "23" }.

Returns
  CMD_SUCCESS, or CMD_WARNING if no such timer is found in tdefs.

References CMD_SUCCESS, CMD_WARNING, osmo_tdef::default_val, OSMO_T_FMT, OSMO_T_FMT_ARGS, osmo_tdef_range_str_buf(), osmo_tdef_val_in_range(), osmo_tdef_vty_parse_T_arg(), osmo_tdef_vty_parse_val_arg(), osmo_tdef::T, T_arg, tdefs, osmo_tdef::val, VTY_NEWLINE, and vty_out().

## ◆ osmo_tdef_vty_set_cmd() [2/2]

return osmo_tdef_vty_set_cmd | ( | vty | ,
|  | tdefs | ,
|  | timer_args |
| ) |  |

## ◆ osmo_tdef_vty_show_cmd()

int osmo_tdef_vty_show_cmd | ( | struct vty * | vty,
|  | struct osmo_tdef * | tdefs,
|  | const char * | T_arg,
|  | const char * | prefix_fmt,
|  |  | ...
| ) |  |

Output one or all timers to the VTY, as for a VTY command like 'show timer [TNNNN]'.

If T_arg is NULL, print all timers in tdefs to the VTY. If T_arg is not NULL, employ osmo_tdef_vty_parse_T_arg() to select one timer from tdefs and print only that to the VTY.

Parameters

  [in] | vty | VTY context for vty_out() of error messages.
  [in] | tdefs | Array of timer definitions.
  [in] | T_arg | Argument string like "T1234", or NULL.
  [in] | prefix_fmt | Arbitrary string to start each line with, with variable printf like arguments.

Returns
  CMD_SUCCESS, or CMD_WARNING if no such timer is found in tdefs.

References CMD_SUCCESS, CMD_WARNING, osmo_tdef_vty_out_all_va(), osmo_tdef_vty_out_one_va(), osmo_tdef_vty_parse_T_arg(), T_arg, and tdefs.

Referenced by osmo_tdef_groups_for_each().

## ◆ osmo_tdef_vty_write()

void osmo_tdef_vty_write | ( | struct vty * | vty,
|  | struct osmo_tdef * | tdefs,
|  | const char * | prefix_fmt,
|  |  | ...
| ) |  |

Write current timer configuration arguments to the vty.

Skip all entries that reflect their default value. The passed prefix string must contain both necessary indent and the VTY command the specific implementation is using. See tdef_vty_config_subnode_test.c and tdef_vty_dynamic_test.c for examples.

Parameters

  [in] | vty | VTY context.
  [in] | tdefs | Array of timers to print, ended with a fully zero-initialized entry.
  [in] | prefix_fmt | Arbitrary string to start each line with, with variable printf like arguments.

References osmo_tdef::default_val, OSMO_T_FMT, OSMO_T_FMT_ARGS, osmo_tdef_for_each, osmo_tdef::T, tdefs, osmo_tdef::val, VTY_NEWLINE, vty_out(), and vty_out_va().

Referenced by osmo_tdef_vty_groups_write().

## ◆ timer_command_string()

static char * timer_command_string | ( | const char * | prefix,
|  | const char * | suffix
| ) |  |
| static

References add_group_args(), osmo_talloc_asprintf, and tall_vty_cmd_ctx.

Referenced by osmo_tdef_vty_groups_init().

## ◆ timer_doc_string()

static char * timer_doc_string | ( | const char * | prefix,
|  | const char * | suffix
| ) |  |
| static

References add_group_docs(), osmo_talloc_asprintf, and tall_vty_cmd_ctx.

Referenced by osmo_tdef_vty_groups_init().

## Variable Documentation

## ◆ argc

argc

Referenced by ALIAS(), argv_concat(), cmd_execute_command_real(), cmd_execute_command_strict(), DEFUN(), DEFUN_ATTR(), DEFUN_HIDDEN(), and gDEFUN().

## ◆ argv

argv

Referenced by ALIAS(), argv_concat(), cmd_execute_command_real(), cmd_execute_command_strict(), DEFUN(), DEFUN_ATTR(), DEFUN_HIDDEN(), and gDEFUN().

## ◆ CMD_SUCCESS

return CMD_SUCCESS

Referenced by osmo_tdef_vty_set_cmd(), and osmo_tdef_vty_show_cmd().

## ◆ g

struct osmo_tdef_group * g = NULL

Referenced by add_group_args(), add_group_docs(), osmo_tdef_groups_for_each(), osmo_tdef_vty_groups_init(), and osmo_tdef_vty_groups_write().

## ◆ global_tdef_groups

struct osmo_tdef_group* global_tdef_groups
| static

Singleton Tnnn groups definition as set by osmo_tdef_vty_groups_init().

Referenced by add_group_args(), add_group_docs(), osmo_tdef_vty_groups_init(), and osmo_tdef_vty_groups_write().

## ◆ group_arg

group_arg = argv[0]

Referenced by osmo_tdef_groups_for_each().

## ◆ T_arg

const char* T_arg = argc > 1 ? argv[1] : NULL

Referenced by osmo_tdef_groups_for_each(), osmo_tdef_vty_set_cmd(), and osmo_tdef_vty_show_cmd().

## ◆ tdefs

struct osmo_tdef* tdefs = NULL

Referenced by osmo_tdef_vty_out_all(), osmo_tdef_vty_out_all_va(), osmo_tdef_vty_parse_T_arg(), osmo_tdef_vty_set_cmd(), osmo_tdef_vty_show_cmd(), and osmo_tdef_vty_write().

## ◆ timer_args

timer_args

Initial value:
{
const char *group_arg
group_arg
group_arg
Definition: tdef_vty.c:299

## ◆ vty

vty

Referenced by cmd_execute_command_strict(), DEFUN(), if(), log_target_create_vty(), vty_create(), vty_down_level(), vty_event(), vty_out_rate_ctr_group2(), vty_out_rate_ctr_group_fmt2(), vty_out_stat_item_group2(), vty_out_statistics_partial2(), vty_read_config_filep(), and vty_reset().